#!/bin/sh

# System Config - dont edit
TVINFOCONF=/etc/tvinfo.conf
TVINFOMAP=/etc/tvinfo.map
TVINFOMERK=/tmp/tvinfo.merk
TVINFOOLD=/tmp/tvinfo.old
TMPFILE=/tmp/tvinfo.tmp
nature=""
format=""
SKIP=0

# first set system time
/usr/bin/ntpdate de.pool.ntp.org &

# reading config

if [ -e $TVINFOCONF ] ; then
  echo "read config from $TVINFOCONF"
  for line in $(cat $TVINFOCONF)
  do
    case $line in
      TVINFONAME*) TVINFONAME=$(echo $line | cut -d"=" -f2);;
      TVINFOPASS*) TVINFOPASS=$(echo $line | cut -d"=" -f2);;
      MARGINSTART*) MARGINSTART=$(echo $line | cut -d"=" -f2);;
      MARGINSTOP*) MARGINSTOP=$(echo $line | cut -d"=" -f2);;
    esac
  done
  MD5PASS=$(echo -n $TVINFOPASS | md5sum | cut -d" " -f1)
  #echo "user:passwort" $TVINFONAME ":" $TVINFOPASS 
else
  echo "TVINFONAME=" > $TVINFOCONF
  echo "TVINFOPASS=" >> $TVINFOCONF
  echo "MARGINSTART=5" >> $TVINFOCONF
  echo "MARGINSTOP=5" >> $TVINFOCONF
  echo "please read manual at http://hthede.de and edit $TVINFOCONF"
  exit
fi

# looking for tvinfomap

if [ ! -e $TVINFOMAP ] ; then
  echo "need to create new $TVINFOMAP"
  echo "servicereference/name@dream=name@tvinfo" > $TMPFILE
  wget -O $TMPFILE http://localhost/web/getallservices
  
  for i in $(cat $TMPFILE | tr -s " " "_")
  do
    if [ $(echo $i | grep "<e2servicereference>") ] ; then
      serviceref=$(echo $i | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
    fi 
    if [ $(echo $i | grep "<e2servicename>") ] ; then
      name=$(echo $i | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
      echo "found $name"
      echo "$serviceref/$name=$name" >> $TVINFOMAP
    fi
  done
  
  rm $TMPFILE
fi

# get already programmed tvinfo - timers
echo "get old timers by tvinfo"

wget -O $TMPFILE http://localhost/web/timerlist

WRITE=0

echo "old timer by tvinfo-" > $TVINFOOLD

for line in $(cat $TMPFILE | tr -s " " "_")
do
  if [ $(echo $line | grep -c tvinfo) -eq 1 ] ; then
    WRITE=1
    WUID=$(echo $line | sed -e s/"<.[a-z|A-Z|0-9]*>"//g -e s/.*tvinfo-//g)
  fi
  
  if [ $(echo $line | grep -c e2timebegin) -eq 1 ] ; then
    WSTART=$(echo $line | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
  fi

  if [ $(echo $line | grep -c e2timeend) -eq 1 ] ; then
    WEND=$(echo $line | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
    
    if [ $WRITE -eq 1 ] ; then
      echo $WSTART $WEND $WUID >> $TVINFOOLD
    fi
  fi

  if [ $(echo $line | grep -c e2timer) -eq 1 ] ; then
    WRITE=0
  fi
done



# get joblist
echo "get joblist from tvinfo"
wget -O $TVINFOMERK "http://www.tvinfo.de/share/openepg/schedule.php?username=$TVINFONAME&password=$MD5PASS"

if [ -s $TVINFOMERK ] ; then
    echo "analysing ..."
    for i in $(cat $TVINFOMERK | tr -s " " "_")
    do
    	if [ $(echo $i | grep "<epg_schedule_entry") ] ; then     	 
    		# check uid
        SKIP=0
        DELETE=0
	      uid=$(echo $i | cut -d\" -f2)

        tvinfochan=$(echo $i | cut -d"=" -f3 | cut -d\" -f2)
  
	      start=$(echo $i | cut -d"=" -f4 | cut -d\" -f2)
        end=$(echo $i | cut -d"=" -f5 | cut -d\" -f2)
        
	      stime=$(echo $start | cut -d"_" -f1,2 | tr -s "-" "." | tr -s "_" "-")
	      etime=$(echo $end | cut -d"_" -f1,2 | tr -s "-" "." | tr -s "_" "-")
  
        # must subtract timezone - diff
        stz=$(echo $start | cut -d"+" -f2 | cut -c 2)
        etz=$(echo $end | cut -d"+" -f2 | cut -c 2)

        stimesec=$(date -d $stime +%s)
        stimesec=$(($stimesec - $(($MARGINSTART*60)) - $(($stz * 60 * 60)) ))
        etimesec=$(date -d $etime +%s)
        etimesec=$(($etimesec + $(($MARGINSTOP*60)) - $(($stz * 60 * 60)) ))

        #check for same tvinfo-uid
        for line in $(cat $TVINFOOLD | grep $uid | tr -s " " "-")
        do
          thisuid=$(echo $line | cut -d"-" -f3)
          thisstart=$(echo $line | cut -d"-" -f1)
          thisend=$(echo $line | cut -d"-" -f2)
	  
	  echo "Check for duplicate event: " $thisuid "?=" $uid
          
          if [ $thisuid = $uid ] ; then
            if [ $thisstart -eq $stimesec -a $thisend -eq $etimesec ] ; then 
              SKIP=1
              echo "Event $uid at same time always here, skip ..."
            else
              DELETE=1
              DELSTART=$thisstart
              DELEND=$thisend
            fi
          fi
        done

        if [ $SKIP -eq 0 ] ; then
  
      		# here channel mapping
      		FOUND=0
      		#echo "look for: $tvinfochan"
      		for service in $(cat $TVINFOMAP | grep $tvinfochan)
      		do
      		  channel=$(echo $service | cut -d"=" -f2)
      		  if [ $channel = $tvinfochan ] ; then
      		    serviceref=$(echo $service | cut -d"/" -f1)
              FOUND=1
              echo "found $tvinfochan in: $service"
            fi        
      		done
        fi

      fi
      
      if [ $SKIP -eq 0 ] ; then
      
       	if [ $(echo $i | grep "<title>") ] ; then
          title=$(echo $i | cut -d"[" -f3 | cut -d"]" -f1)
          
          title=$(echo $title | sed -e 's//ae/g' -e 's//oe/g' -e 's//ue/g' -e 's//ss/g' -e 's//Ae/g' -e 's//Oe/g' -e 's//Ue/g' -e 's/[^a-zA-Z0-9_-]*//g')
          		
          echo "found: $title: $stime $etime @$tvinfochan" 
        fi
        
        if [ $(echo $i | grep "<nature>") ] ; then
          nature=$(echo $i | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
        fi
        
        if [ $(echo $i | grep "<format>") ] ; then
          format=$(echo $i | sed -e s/"<.[a-z|A-Z|0-9]*>"//g)
          if [ -n $nature ] ; then
            format=$(echo $format"/")
          fi
        fi
        
        
        if [ $(echo $i | grep "</epg_schedule_entry>") ] ; then  
      		#because it is last line i try to send the command here
          
          if [ $FOUND -eq 1 ] ; then
            desc=$(echo $format$nature"_tvinfo-"$uid)

            # delete old timer only if a new one could be programmed
              
            if [ $DELETE -eq 1 ] ; then  
              echo "try to delete changed timer"          
              wget -O $TMPFILE http://localhost/web/timerdelete?sRef=$serviceref\&begin=$DELSTART\&end=$DELEND
              if [ -e $TMPFILE ] ; then
                cat $TMPFILE | grep "<e2statetext>" | sed -e s/"<.[a-z|A-Z|0-9]*>"//g
        	     rm $TMPFILE
        	    fi
        	  fi

            # program new timer
            echo "try to add new timer"
            if [ $# -eq 0 ] ; then
              wget -O $TMPFILE http://localhost/web/timeradd?sRef=$serviceref\&begin=$stimesec\&end=$etimesec\&name="$title"\&description="$desc"\&eit=\&disabled=0\&justplay=0\&afterevent=0
            else
              echo wget -O $TMPFILE http://localhost/web/timeradd?sRef=$serviceref\&begin=$stimesec\&end=$etimesec\&name="$title"\&description="$desc"\&eit=\&disabled=0\&justplay=0\&afterevent=0
            fi
              
            if [ -e $TMPFILE ] ; then
              cat $TMPFILE | grep "<e2statetext>" | sed -e s/"<.[a-z|A-Z|0-9]*>"//g
        	    rm $TMPFILE
        	  fi
          else
            echo "no mapping channel found for: \"$tvinfochan\", please edit $TVINFOMAP"
          fi 
        fi
      fi
    done
else
  echo "ERROR: result is empty: check internet connection and $TVINFOCONF or service is not available at the moment"
fi
      
#rm $TVINFOMERK     
